Bug 106515 - lcl_GetDefaultBulletFont font set to legacy "StarSymbol" so unexpected system font fallback occurs
Summary: lcl_GetDefaultBulletFont font set to legacy "StarSymbol" so unexpected system...
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: graphics stack (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium minor
Assignee: Caolán McNamara
QA Contact:
URL:
Whiteboard: target:5.4.0 target:5.3.3
Keywords:
Depends on:
Blocks:
 
Reported: 2017-03-12 18:04 UTC by V Stuart Foote
Modified: 2017-04-05 14:56 UTC (History)
7 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description V Stuart Foote 2017-03-12 18:04:32 UTC
Description:
lcl_GetDefaultBulletFont [2] sets Bullet font to StarSymbol which of course was dropped from OOo before LO. The OpenSymbol glyphs are picked up in UI, but with non-existent StarSymbol font called while setting Options/Customization a font fallback occurs and System selected font is substituted and displayed for use in the Special Character dialog.

On Windows 8, 8.1 and 10 that is Segoe UI -- so Unicode page displayed in LO Special Character dialog is very disjointed. 

Believe this should probably have been changed in OOo era, when other adjustments were made to the bullet list [2], but it remains.

At this point seems we should change the font from defunct StarSymbol to OpenSymbol [1].  The remaining PUA glyph assignment for BLACK DIAMOND SUIT U+e00c and BLACK SQUARE U+e00a to their OpenSymbol Unicode value of U+2666 and U+25a0 respective [3]






Steps to Reproduce:
n/a

Actual Results:  
n/a

Expected Results:
n/a


Reproducible: Always

User Profile Reset: Yes

Additional Info:
=-refs-=
[1] http://opengrok.libreoffice.org/xref/core/svx/source/dialog/svxbmpnumvalueset.cxx#81
    http://opengrok.libreoffice.org/xref/core/svx/source/sidebar/nbdtmg.cxx#66
    http://opengrok.libreoffice.org/xref/core/cui/source/tabpages/numpages.cxx#160
[2] https://bugs.documentfoundation.org/show_bug.cgi?id=92657#c14
[3] http://opengrok.libreoffice.org/xref/core/svx/source/dialog/svxbmpnumvalueset.cxx#69
    http://opengrok.libreoffice.org/xref/core/cui/source/tabpages/numpages.cxx#134


User-Agent: Mozilla/5.0 (Windows NT 10.0; WOW64; rv:51.0) Gecko/20100101 Firefox/51.0
Comment 1 V Stuart Foote 2017-03-12 18:24:15 UTC
(In reply to V Stuart Foote from comment #0)
> lcl_GetDefaultBulletFont [2]

s/[2]/[1]/
Comment 2 Buovjaga 2017-03-16 08:33:32 UTC
I believe you -> NEW
Comment 3 Caolán McNamara 2017-03-31 11:31:06 UTC
This report seems the wrong way around, a proposed solution for a problem, but I'm unclear what the exact problem to be solved is ? "While setting Options/Customization a font fallback occurs and System selected font is substituted and displayed for use in the Special Character dialog." doesn't explain the problem to me
Comment 4 Regina Henschel 2017-03-31 12:24:11 UTC
I guess it is visible in this scenario:
Write some paragraphs and make a bulleted list from it by clicking on the "Bulleted list" item in the toolbar. Right-click a paragraph and click on "Bullets and Numbering" in the context menu. Click on tab "Customize" of that dialog. Click on "Select". The special character dialog opens. It has the font "Segoe UI" preselected (for me on Windows 7).

[I think it is an additional bug, that the special character dialog does not show that font preselected, which is set in the style that is chosen for this list in "Character style".]
Comment 5 Caolán McNamara 2017-03-31 13:46:10 UTC
Aha, yeah now I understand. Yeah we should ideally take the font from the style and use OpenSymbol not StarSymbol there as the default font in the UI.
Comment 6 Commit Notification 2017-03-31 14:26:29 UTC
Caolán McNamara committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=f4b7338f989bd5f7e934c4dc38045e812eb3d59f

Resolves: tdf#106515 use OpenSymbol, not StarSymbol as the default bullet font

It will be available in 5.4.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 7 Commit Notification 2017-03-31 14:26:35 UTC
Caolán McNamara committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=011e1cdbf33e50626f1fefa8b7b4031fa368f3e8

Related: tdf#106515 show OpenSymbol if unavailable StarSymbol requested

It will be available in 5.4.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 8 Caolán McNamara 2017-03-31 14:29:01 UTC
I think that'll do what we want, there's a 5-3 backport of one of the commits which should achieve the overall result in gerrit
Comment 9 V Stuart Foote 2017-03-31 23:06:21 UTC
@Caolán, thanks! I'll test as soon as a master TB rolls with it.

But, what about the two PUA mapped glyphs [1][2], with StarSymbol gone, wouldn't it be better to remap their Unicode values as provided in OpenSymbol?

0xe00c - BLACK DIAMOND SUIT  --> 0x2666 
0xe00a - BLACK SQUARE --> 0x25a0

=-ref-=
[1] http://opengrok.libreoffice.org/xref/core/svx/source/dialog/svxbmpnumvalueset.cxx#69

[2] http://opengrok.libreoffice.org/xref/core/cui/source/tabpages/numpages.cxx#134
Comment 10 Caolán McNamara 2017-04-02 14:15:45 UTC
If doing so solves some concrete problem then I suggest filing a new bug about it rather than mixing things up
Comment 11 V Stuart Foote 2017-04-04 03:14:28 UTC
Verified fixed on Windows 10 Pro 64-bit en-US with
Version: 5.4.0.0.alpha0+ (x64)
Build ID: 646e52adf4a84ca5beab7bae1e1fae4e793c4896
CPU threads: 8; OS: Windows 6.19; UI render: GL; 
TinderBox: Win-x86_64@62-TDF, Branch:MASTER, Time: 2017-04-03_22:00:33
Locale: en-US (en_US); Calc: CL

With change to OpenSymbol, using the "More Bullets" dialog and "Select" button--the Character map picker now opens to OpenSymbol rather than system default (Segoe on Windows 10).

The PUA mapped glyphs render from their OpenSymbol mapping (which is normally going to be present with the LO install) this just seemed an opportunity to clean up a couple of the dozens hardcoded PUA glyphs to use a more general Unicode code point.
Comment 12 Commit Notification 2017-04-05 14:56:46 UTC
Caolán McNamara committed a patch related to this issue.
It has been pushed to "libreoffice-5-3":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=7bb46f684ca939fbbbe67bdb1e427e37eec430a7&h=libreoffice-5-3

Related: tdf#106515 show OpenSymbol if unavailable StarSymbol requested

It will be available in 5.3.3.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.